package fxHarakka.luokat;


/**
 * ----------Yksittäisen projektin luokka------------
 * |
 * | - Ei tiedä muista luokista mitään.
 * | - Huolehtii yksittäisen projektin kentistä eli:
 * |       -aihe
 * |       -nimi
 * |       -kesto (viikoissa)
 * |       -suoritettu (viikoissa)
 * | - Osaa get metodit omille attribuuteille.
 * | - Osaa parsia itsensä merkkijonoksi
 * --------------------------------------------------
 */
public class Projekti {

    private String aihe;        //projektin aihealue
    private String nimi;        //projektin nimi
    private final int id;       //projekti id --> ensimmäinen projekti alkaa id nro 1
    private int kesto;
    private int suoritettu;
    private static int seuraavaNro = 1;


    //default parametritön muodostaja
    public Projekti() {
        this.id = 0;
        this.nimi = "";
        this.aihe = "";
    }

    //parametrillinen muodostaja
    public Projekti(int id, String nimi, String aihe){
        this.id = id;
        this.nimi = nimi;
        this.aihe = aihe;
    }

    //-----------------------METODIT - PROJEKTI----------------------------

    /** aliohjelma uuden projektin luomiselle. varaa id numeron itselleen.
     *
     * @param nimi projektin nimi
     * @param aihe projektin aihealue
     *
     * @return
     * @example <pre name="test">
     * #import fxHarakka.luokat.*;
     *
     *  Projekti testi1 = luoProjekti("kvantti", "fysiikka");
     *  testi1.toString() === "kvantti | fysiikka | 1";
     *
     *  Projekti testi2 = luoProjekti("Nakki", "Keitto");
     *  testi2.toString() === "Nakki | Keitto | 2";
     * </pre>
     */
    public static Projekti luoProjekti(String nimi, String aihe){       //static koska ei tarvita this
        int nro = seuraavaNro++; // huom jälkilisäys
        Projekti projekti = new Projekti(nro, nimi, aihe);


        return projekti;

    }

    /**
     *
     * @return palauttaa projektin id numeron
     */
    public int getId() {
        return id;
    }

    /**
     *
     * @return palauttaa projektin nimen
     */
    public String getNimi() {
        return nimi;
    }

    /**
     *
     * @return palauttaa projektin aiheen
     */
    public String getAihe() {
        return aihe;
    }

    @Override
    public String toString(){
        String strg = this.nimi + " | " + this.aihe + " | " + this.id;

        return strg;
    }

    //maini testaamista varten
    public static void main(String[] args){

    }


}
