package fxHarakka.luokat;

import java.util.ArrayList;
import java.util.Collections;

/**---------------Projektien (monikko) luokka--------------------------------
 * |                                                    | -Projekti         |
 * | - lisää ja poistaa projekteja                      |                   |
 * |                                                    |                   |
 * | - Huolehtii listan pituuden riittävyydestä jos     |                   |
 * |    täyttyy                                         |                   |
 * |                                                    |                   |
 * | - Lukee ja kirjoittaa projektit.dat tiedostoon     |                   |
 * |                                                    |                   |
 * | - Etsii ja lajittelee (avustajana projekti luokka) |                   |
 */
public class Projektit {
    private int maara;
    //private int maxMaara; //tätä ei näillänäkymin tarvitse johtuen tietorakenteesta
                            //--> ei tarvitse itse huolehtia kasvatuksesta
    private String kokoNimi = ""; //projektit nimi
    private String tied = "";     //tiedostosijainti josta luetaan ja kirjoitetaa
    private ArrayList<Projekti> alkiot = new ArrayList<>(); //varaa autom. oikean määrän alkioita


    //-----------------------MUODOSTAJAT - PROJEKTIT----------------------------

    /**
     *
     * @param maara     Nykyinen alkioiden määrä
     * @param kokoNimi  projektikokoelman nimi
     * @param tied      tiedostosijainti josta luetaan ja talletetaan
     */
    public Projektit(int maara, String kokoNimi, String tied) {
        this.maara = maara;
        this.kokoNimi = kokoNimi;
        this.tied = tied;
    }

    /**
     * Oletusmuodostaja. voidaan käyttää ylempää jos halutaan muokata ominaisuuksia kuten nimeä esim tilanteessa
     * jossa halutaan jatkossa lisätä uusi "istunto".
     *
     *
     * oletuksena luo 10 tyhjää alkioita
     */
    public Projektit() {
        this.maara = 0;
        this.kokoNimi = "Harakka";
        this.tied = "projektit.dat";
    }



    //-----------------------METODIT - PROJEKTIT----------------------------

    /**
     *
     * @return palauttaa tietorakenteen alkioiden määrän
     */
    public int getMaara() {
        return maara;
    }

    /**
     *
     * @param maara asettaa tietorakenteen alkioiden määrän
     */
    public void setMaara(int maara) {
        this.maara = maara;
    }




}
